# coding=Windows-1250

# ----- importy -----

import numpy                                # import funkc knihovny numpy
from numpy import rot90
from numpy import array
from numpy import dot

import scipy                                # import funkc knihovny scipy
from scipy import signal
from scipy import integrate

import matplotlib                           # import funkc knihovny matplotlib
import matplotlib.pyplot as pyplot

from math import sin, pi                    # import zkladnch mat. funkc
from random import uniform as random        # import generovn nhodnch sel

from serial import Serial                   # import sriovho rozhran

from threading import Timer                 # import asovae
import time                                 # import typu as

# ----- definice globlnch promnnch -----

global Sys, SP, t, ui, u, y, x, I, D, OK

us = [0.0]*10
ys = [0.0]*10
NameStep = ["StepIn","StepOut"]             #  nzev pro promnn zptn kroky
NameTf = ["TfIn","TfOut"]                   #  nzev pro Tf

# ----- funkce -----

def frange(start, end = None, step = None):
    "Funkce range generujc posloupnost sel float"

    if end == None:                         # pokud nezadn konec
        end = start + 0.0                   #  konec = start
        start = 0.0                         #  start = 0

    if step == None:                        # pokud nezadn krok
        step = 1.0                          #  generovn s krokem 1

    fr = []
    while 1:                                # generovn hodnot
        next = start + len(fr) * step       # vytvoen dal hodnoty v posloupnosti
        if step > 0 and next >= end:
            break
        elif step < 0 and next <= end:
            break
        fr.append(next)                     # pidn hodnoty do vsl. promnn
        
    return fr

def time(tmax, step):
    "Vygenerovn asu"
    # tmax - as, do kterho se generuje, step - dlka kroku
    if not type(step) == type([]):                  # pokud stejn krok
        return frange(0, tmax + step, step)         # vygenerovat
    else:                                           # pokud rozdln krok
        t1 = frange(0, tmax + step[0], step[0])
        t2 = frange(0, tmax + step[1], step[1])
        return [t1,t2]                              # vygenerovat 2 pole asu

def step(t, start, max = 1.0, min = 0.0, typ = 'float'):
    "Vygenerovn jednotkovho skoku"
    # t - generovn pro as t, start - skok v tomto ase
    
    if type(t[0]) == type([]):                      # pokud rozdln asovn
        t = t[0]                                    # potat podle bloku regultoru
    
    u = [0.0]*len(t)                                # vytvoen vstupu u
    for i in range(len(u)):
        if not(type(start) == type([])):            # pokud nen vektor
            if t[i] > start:                        # pokud u skok
                u[i] = max                          # u = max
            else:
                u[i] = min                          # u = min
            if typ == 'int':
                u[i] = int(round(u[i]))
        else:                                       # pokud vektor
            u[i] = []
            for j in range(len(start)):             # pro kad slo
                if t[i] > start[j]:                 # pokud u skok
                    if type(max) == type([]):       # pokud max vektor
                        u[i] += [max[j]]            # u = max
                    else:
                        u[i] += [max]               # u = max
                else:
                    if type(min) == type([]):       # pokud min vektor
                        u[i] += [min[j]]            # u = min
                    else:
                        u[i] += [min]               # u = min
            if typ == 'int':                        # pokud integer
                for j in range(len(start)):
                    u[i][j] = int(round(u[i][j]))   # zaokrouhlit
                
        
    return u        

def sine(t, period, amplitude = 1.0, shift = 0.0, typ = 'float'):
    "Vygenerovn sinusovho signlu"
    # t - generovn pro as t, period - perioda sinusovho prbhu
    if type(t[0]) == type([]):                      # pokud rozdln asovn
        t = t[0]                                    # potat podle bloku regultoru
    
    u = [0.0]*len(t)                                # vytvoen vstupu u
    for i in range(len(u)):
        if not(type(period) == type([])):           # pokud nen vektor
            u[i] = amplitude * sin((2*pi*(t[i] - shift))/period)  # pepotn sinusovho prbhu
            if typ == 'int':
                u[i] = int(round(u[i]))
        else:                                       # pokud vektor
            u[i] = []
            for j in range(len(period)):            # pro kad slo
                if type(amplitude) == type([]):     # pokud amplituda vektor
                    if type(shift) == type([]):     # pokud posun vektor
                        u[i] += [amplitude[j] * sin((2*pi*(t[i] - shift[j]))/period[j])]  # pepotn sinusovho prbhu
                    else:
                        u[i] += [amplitude[j] * sin((2*pi*(t[i] - shift))/period[j])]  # pepotn sinusovho prbhu
                else:                               # pokud amplituda slo
                    if type(shift) == type([]):     # pokud posun vektor
                        u[i] += [amplitude * sin((2*pi*(t[i] - shift[j]))/period[j])]  # pepotn sinusovho prbhu
                    else:
                        u[i] += [amplitude * sin((2*pi*(t[i] - shift))/period[j])]  # pepotn sinusovho prbhu
            if typ == 'int':                        # pokud integer
                for j in range(len(period)):
                    u[i][j] = int(round(u[i][j]))   # zaokrouhlit
            
    return u
    
def pulse(t, period, width, saw = False, amplitude = 1.0, shift = 0.0, typ = 'float'):
    "Vygenerovn PWM signlu nebo pily"
    # t - generovn pro as t, period - perioda PWM prbhu, width - dlka jedniky
    if type(t[0]) == type([]):                      # pokud rozdln asovn
        t = t[0]                                    # potat podle bloku regultoru
    
    u = [0.0]*len(t)                                # vytvoen vstupu u

    if not(type(period) == type([])):               # pokud nen vektor
        value = False                               #  zapisovat nulu
        k = 0                                       # nult perioda
    else:                                           # pokud je
        value = []
        k = []
        for i in range(len(period)):
            value += [False]                        #  zapisovat nulu vude
            k += [0]                                # nult periody
            
    for i in range(len(u)):
        if not(type(period) == type([])):           # pokud nen vektor
            if t[i] >= k*period + shift:                # pokud zatek nov periody
                k = k + 1                               #  pist periodu
                if saw == True:                         #  pokud signl pily
                    u[i] = amplitude*(t[i] - (k-1)*period - shift)/width #   zpis pilov hodnoty
                else:                                   #  jinak
                    u[i] = amplitude                    #  zpis 1
                value = True                            #  pt zapisovat 1
            elif t[i] >= ((k-1)*period + shift + width): # pokud konec signlu v period
                value = False                           #  zapisovat 0
            elif value == True:                         # pokud se m zapisovat 1
                if saw == True:                         #  pokud signl pily
                    u[i] = amplitude*(t[i] - (k-1)*period - shift)/width #   zpis pilov hodnoty
                else:                                   #  jinak
                    u[i] = amplitude                    #  zpis 1
            if typ == 'int':
                u[i] = int(round(u[i]))
        else:
            u[i] = []
            for j in range(len(period)):                # pro kad slo
                # --- konverze pol ---
                if (type(width) == type([])):       
                    widthX = width[j]
                else:
                    widthX = width
                if (type(saw) == type([])):
                    sawX = saw[j]
                else:
                    sawX = saw
                if (type(amplitude) == type([])):
                    amplitudeX = amplitude[j]
                else:
                    amplitudeX = amplitude
                if (type(shift) == type([])):
                    shiftX = shift[j]
                else:
                    shiftX = shift                    
                    
                if t[i] >= k[j]*period[j] + shiftX:         # pokud zatek nov periody
                    k[j] = k[j] + 1                         #  pist periodu
                    if sawX == True:                        #  pokud signl pily
                        u[i] += [amplitudeX*(t[i] - (k[j]-1)*period[j] - shiftX)/widthX] #   zpis pilov hodnoty
                    else:                                   #  jinak
                        u[i] += [amplitudeX]                #  zpis 1
                    value[j] = True                         #  pt zapisovat 1
                elif t[i] >= ((k[j]-1)*period[j] + shiftX + widthX): # pokud konec signlu v period
                    value[j] = False                        #  zapisovat 0
                    u[i] += [0.0]
                elif value[j] == True:                      # pokud se m zapisovat 1
                    if sawX == True:                        #  pokud signl pily
                        u[i] += [amplitudeX*(t[i] - (k[j]-1)*period[j] - shiftX)/widthX] #   zpis pilov hodnoty
                    else:                                   #  jinak
                        u[i] += [amplitudeX]                #  zpis 1
                elif value[j] == False:
                        u[i] += [0.0]
            if typ == 'int':                                # pokud integer
                for j in range(len(period)):
                    u[i][j] = int(round(u[i][j]))           # zaokrouhlit
    return u
 
def f(x,t,u,A,B):
    " Stavov funkce"
    
    return rot90(dot(A,rot90(rot90(rot90([x])))) + dot(B,u))[0]   # x' = Ax + Bu

def rightTfZ(TfZ):
    "Pevod Z-funkce na sprvn vpoetn formt"
    
    if len(TfZ[0]) < len(TfZ[1]):                       # pokud nem funkce vyrovnan itatel a jmenovatel
        for i in range(len(TfZ[1])-len(TfZ[0])):
            TfZ[0] = [0.0] + TfZ[0]                     #  dorovnat nulami
    if not(TfZ[1][0] == 1):                             # pokud nen 1. len jmenovatele 1
        x = TfZ[1][0]
        for i in range(len(TfZ[0])):                    #  -> pepotat aby byl (vydlen ostatnch len
            TfZ[0][i] = TfZ[0][i]/x
        for i in range(len(TfZ[1])):
            TfZ[1][i] = TfZ[1][i]/x
    return TfZ
 
def correctSys(Sys):
    if type(Sys) == type([]):                            # pokud pole
            if len(Sys) == 1:                            # pokud sriov rozhran
                try:
                    SP = Serial(Sys[0], 115200, timeout=0.02) # inicializace SP
                    return Sys
                except:
                    print "Nelze se pipojit k " + str(Sys[0])
                    return Sys
            elif len(Sys) == 2:                          # pokud Sys
                if type(Sys[0]) == type(f):
                    return Sys
                else:
                    SS1 = scipy.signal.tf2ss(Sys[0],Sys[1])   #  vpoet diferencilnch rovnic z Sys
                    A1 = SS1[0]                             #  zpis matic
                    B1 = SS1[1]
                    C1 = SS1[2]
                    D1 = SS1[3]
                    if len(A1) == 0:                        #  pokud przdn matice, zadat do nich 0
                        A1 = array([[0]])
                    if len(B1) == 0:
                        B1 = array([[0]])
                    if len(C1) == 0:
                        C1 = array([[0]])
                    if len(D1) == 0:
                        D1 = array([[0]])
                    elif not(type(D1[0]) == type([])):
                        D1 = array([[D1[0]]]) 
                    A1 = rot90(rot90(A1))                   #  rotace matic o 180
                    B1 = rot90(rot90(B1))
                    C1 = rot90(rot90(C1))
                    D1 = rot90(rot90(D1))
                    return [A1,B1,C1,D1]
            elif len(Sys) == 4:                          # pokud SS
                A1 = array(Sys[0])                       #  pevod na typ ntarray
                B1 = array(Sys[1])
                C1 = array(Sys[2])
                D1 = array(Sys[3])
                return [A1,B1,C1,D1]
            elif len(Sys) == 3:                          # pokud TfZ
                if type(Sys[0]) == type([]):
                    Sys = rightTfZ(Sys)                   #  pevod na sprvn formt
                    return Sys
                else:
                    return Sys
            else:                                       # patn zadan Sys
                return Sys
    else:
        return Sys

def initU(input):
    global Sys, SP, t, ui, u, y, x, I, D
    
    ui = [0.0]*len(t[0])                                # vytvoen pole vstupnch hodnot 
    if type(input[0]) == type([]):                      # pevod vstupnch pol na ntarray
        for i in range(len(input)):
            ui[i] = rot90(rot90(rot90(array([input[i]]))))
    else:
        for i in range(len(input)):
            ui[i] = array([[input[i]]])    

    u = [0.0]*2                                         # vytvoen promnnch vstup u1, u2
    x = [0.0]*2
    y = [0.0]*2                                         # vytvoen promnnch vstup y1, y2
    for i in range(2):                                  # naplnn pol vstup a vstup
        u[i] = [0.0]*len(t[i])
        y[i] = [0.0]*len(t[i])
    
    u[0][0] = ui[0]                                     # prvn vstupn hodnota u1 stejn jako ui
    u[0][1] = ui[1]
    u[1][0] = ui[0]
    I = [0.0]*2                                         # vytvoen integran a derivan sloky
    D = [0.0]*2
    

def initSys(num,x0,typ):
    global Sys, SP, t, ui, u, y, x, I, D

    if num == 1:
        u[num][0] = y[num-1][0]

    # ---------- ODE ----------
    
    if type(Sys[num]) == type([]):                      # pokud Sys[num] je ODE
        if len(Sys[num]) == 2:
            if type(Sys[num][0]) == type(f):
                Sys[num][0](x0[num])
                y[num][0] = array([x0[num]])
                
    # ---------- TF ----------            
        if (len(Sys[num]) == 2) or (len(Sys[num]) == 4): # pokud Sys[num] je Tf nebo SS
            if not(type(Sys[num][0]) == type(f)):
                x[num] = [array([[0.0]]*len(Sys[num][0]))]*len(t[num]) # inicializace promnnch pro vpoet penosu Sys[num]
                if not (len(Sys[num][0]) == len(x0[num])):
                    xx0 = [0.0]*len(Sys[num][0])
                    for i in range(len(x0[num])):
                        xx0[i] = x0[num][i]
                    x0[num] = xx0
                if typ == 'int':                            # pokud integer tak zaokrouhlit
                    x[num][0] = int(round(rot90(rot90(rot90(array([x0[num]]))))))
                    y[num][0] = int(round(dot(Sys[num][2],x[num][0]) + dot(Sys[num][3],u[num][0])))
                else:                                       # jinak ne    
                    x[num][0] = rot90(rot90(rot90(array([x0[num]]))))
                    y[num][0] = dot(Sys[num][2],x[num][0]) + dot(Sys[num][3],u[num][0])
                
    # ---------- PID ----------
    
        if (len(Sys[num]) == 3) and not(type(Sys[num][0]) == type([])): # inicializace promnnch PID regultoru
            y[num][0] = rot90(array([[0.0]*len(u[num][0])]))        
        
    # ---------- TFZ + Serial ----------

        else:
            y[num][0] = array([x0[num]])
            
    # ---------- Funkce ----------
    
    else:                                               # pokud funkce
        p = Sys[num]([0.0]*50,0.0,[0.0]*50)                # inicializace promnnch
        x[num] = [0.0]*len(t[num])                               
        if not (len(p) == len(x0[num])):
            xx0 = [0.0]*len(p)
            for i in range(len(x0[num])):
                xx0[i] = x0[num][i]
                if typ == 'int':                        # pokud integer tak zaokrouhlit
                    xx0[i] = int(round(xx0[i]))
        else:
            xx0 = x0[num]
            if typ == 'int':                            # pokud integer tak zaokrouhlit
                for i in range(len(xx0)):
                    xx0[i] = int(round(xx0[i]))
        x[num][0] = array([xx0])

        yx = []
        for i in range(len(rot90(u[0][0])[0])):
            yx += [xx0[i]]
            if typ == 'int':                            # pokud integer tak zaokrouhlit
                yx[i] = int(round(yx[i]))
        y[num][0]  = rot90(rot90(rot90(array([yx]))))

def Init(TF1,TF2,time,input,x0,typ):                    # inicializace
    global Sys, SP, t, ui, u, y, x, I, D
    
    Sys = [0]*2
    Sys[0] = correctSys(TF1)                             # prava funkce regultoru
    Sys[1] = correctSys(TF2)                             # prava funkce systmu
    
    t = [0]*2                                           # inicializace pole as
    if type(time[0]) == type([]):                       # pokud rozdln asovn
        t[0] = time[0]                                  # nastavit asovn pro kad systm
        t[1] = time[1]
    else:                                               # pokud stejn
        t[0] = time                                     # nastavit spolen asovn
        t[1] = time
    
    try:    
        initU(input)                                        # vytvoen pol vstup a vstup
    except:
        print "Nelze inicializovat pole vstup"
        
    try:
        initSys(0,x0,typ[0])                                # vpoet potench hodnot systm
    except:
        print "Nelze inicializovat Blok 1"
    
    try:
        initSys(1,x0,typ[1])
    except:
        print "Nelze inicializovat Blok 1"
    
def CalcSystem(num,i,typ,integration):
        global Sys, SP, t, ui, u, y, x, I, D    
        tz = [0.0,0.0]                                  # inicializace asovho kroku
        tz[0] = t[num][i]                               #  zapsn as kroku
        tz[1] = t[num][i+1]
        
        if typ == 'int':                                # pokud integer tak zaokrouhlit vstup
            for j in range(len(u[num][i+1])):
                  u[num][i+1][j] = int(round(u[num][i+1][j]))
        if type(Sys[num]) == type([]):
            
            # ---------- ODE ----------
            
            if (len(Sys[num]) == 2):
                if type(Sys[num][1]) == type(f):
                    ys = Sys[num][1](tz[1]-tz[0],u[num][i+1])
                    y[num][i+1] = rot90(rot90(rot90(array([ys]))))
                    
                    
            # ---------- TF ----------
            
            if (len(Sys[num]) == 2) or (len(Sys[num]) == 4): # vpoet penosu pomoc dif. rovnic (Tf, SS)
                if not(type(Sys[num][0]) == type(f)):
                    if type(integration) == type(f):
                        xz = integration(f,rot90(x[num][i])[0],tz,u[num][i+1],Sys[num][0],Sys[num][1])
                    else:
                        xz = integrate.odeint(f,rot90(x[num][i])[0],tz,args=(u[num][i+1],Sys[num][0],Sys[num][1],))
                    x[num][i+1]=rot90(rot90(rot90([xz[1]])))
                    y[num][i+1] = dot(Sys[num][2],x[num][i+1]) + dot(Sys[num][3],u[num][i+1])

            # ---------- Serial ----------
        
            elif len(Sys[num]) == 1:                    # penos po sriov lince
                s = rot90(u[num][i+1])[0]
                ys = []
                for j in range(len(s)):
                    SP.write(str(s[j]) + "\n")          # odesln dat
                    q = SP1.readline()                  # pijet dat
                    try:
                        ys += [float(q)]                # peveden na slo
                    except:
                        ys += [0.0]
                y[num][i+1] = rot90(rot90(rot90(array([ys]))))

            # ---------- PID ----------                
                
            elif (len(Sys[num]) == 3) and not(type(Sys[num][0]) == type([])): # vpoet penosu PID reg.
                P = Sys[num][0]*u[num][i+1]               # part. skoka
                I[num] = I[num] + (Sys[num][1]*u[num][i+1])*(tz[1]-tz[0])
                D[num] = (Sys[num][2]*u[num][i+1] - Sys[num][2]*u[num][i])/(tz[1]-tz[0])
                y[num][i+1] = P + I[num] + D[num]  # souet

            # ---------- TFZ ----------
                        
            else:                                       # vpoet penosu diskrtn (TfZ)
                z1 = Sys[num][0][0]*u[num][i+1][0][0]
                z2 = 0
                for j in range(len(Sys[num][0])-1):     #  vpoet vstupnch smyek
                    if i - j - 1 >= 0:
                        z1 = z1 + Sys[num][0][j+1]*u[num][i - j][0][0]               
                for j in range(len(Sys[num][1])-1):     #  vpoet vstupnch smyek
                    if i - j - 1>= 0:
                        z2 = z2 + Sys[num][1][j+1]*y[num][i - j][0][0]
                y[num][i+1] = array([[z1-z2]])          #  vsledek

        # ---------- Funkce ----------
        
        else:                                           #  vpoet pes zadanou funkci
            if type(integration) == type(f):
                xz = integration(Sys[num],x[num][i][0],tz,rot90(u[num][i+1])[0])
                x[num][i+1] = array([xz])
                yx = []
                for j in range(len(rot90(u[num][0])[0])):
                    yx += [xz[j]]
                y[num][i+1]  = rot90(rot90(rot90(array([yx]))))
                
            else:
                xz = integrate.odeint(Sys[num],x[num][i][0],tz,args=(rot90(u[num][i+1])[0],))
                x[num][i+1] = array([xz[1]])
                yx = []
                for j in range(len(rot90(u[num][0])[0])):
                    yx += [xz[1][j]]
                y[num][i+1]  = rot90(rot90(rot90(array([yx]))))
        
        if typ == 'int':                                # pokud integer, tak zaokrouhlit vstup
            for j in range(len(y[num][i+1])):
                  y[num][i+1][j] = int(round(y[num][i+1][j]))

def Final():
    global Sys, SP, t, ui, u, y, x, I, D
    for i in range(len(y[1])):                          # pevod vech vstupnch hodnot z matice na float
        y[1][i] = numpy.ndarray.tolist(rot90(y[1][i]))[0]
    if type(Sys[0]) == type([]):                        # pokud TF1 = serial
        if len(Sys[0]) == 1:
            SP.close()                                  # zavt port
    if type(Sys[1]) == type([]):                        # pokud TF2 = serial
        if len(Sys[1]) == 1:
            SP.close()                                  # zavt port
                
def Sim(SysF1, SysF2, time, input, feedback = False, x0 = [[0.0],[0.0]], noise = False, noiseVal = [-0.01,0.01], typ = ['float','float'], integration = ['','']):
    "Simulace penosu"
    # SysF1,SysF2 - penosov funkce, t - asov kroky, ui - vstup,
    # feedback - zporn zptn vazba, x0 - poten hodnota, noise - um, noiseVal - velikost umu
    global Sys, SP, t, ui, u, y, x, I, D
    
    Init(SysF1,SysF2,time,input,x0,typ)
    
    j = 0
    for i in range(len(t[0])-1):                        # regultor a systm v srii
        try:
            CalcSystem(0,i,typ[0],integration[0])
        except:
            print "Nelze vypotat Blok 1"
            return [0.0]*len(t[1])
        u[1][j+1] = y[0][i+1]
        
        if noise == True:                                   # pokud um
            u[1][j+1] = u[1][j+1] + random(val[0], val[1])  # pipotat um
           
        while t[0][i+1] >= t[1][j+1]:
            if len(t[1]) > (j+2):
                u[1][j+2] = u[1][j+1]
            try:
                CalcSystem(1,j,typ[1],integration[1])
            except:
                print "Nelze vypotat Blok 2"
                return [0.0]*len(t[1])
            j = j+1
            if j == (len(t[1])-1):
                break
        if not i == len(t[0])-2:
            u[0][i+2] = ui[i+2]
            
            if feedback == True:                        # pokud zptn vazba
                u[0][i+2] = u[0][i+2] - y[1][j]         #  pepotat vstupn hodnotu    
    Final()
    
    return y[1]                                         # vrtit vsledek

def Ted():
    global OK
    OK = False
    
def status(COM, t, input = True, output = True, signal = 0, PID = 0):
    global OK
    import time
    
    try:
        SP = Serial(COM, 115200, timeout=0.02)          # Inicializovat spojen
    except:
        print 'Spojen nebylo navzno'
        return [0.0]*len(t)                             # navrtit pole nul
    
    u = []                                              # inicializace promnnch
    y = []
    
    SP.write("p0\n")                                    # zapsat poten hodnotu
    SP.write("h0\n")                                    # zapsat konenou hodnotu
    
    if type(PID) == type(u):                            # nov nastaven konstant PID regultoru
        SP.write("a" + str(PID[0]) + "\n")              #  KP
        SP.write("b" + str(PID[1]) + "\n")              #  KI
        SP.write("c" + str(PID[2]) + "\n")              #  KD
    
    OK = False
    value = 0
    T1 = time.time()                                    # Stopky - zatek
    for i in range(len(t)):
        
        while OK == True:                               # dokud neupnyne poteban as, nepustit dl
            w = 0
        
        OK = True
        if not (i == len(t)-1):
            stp = t[i+1] - t[i]
        tim = Timer(stp, Ted)                           # spustit asova na posln dat
        tim.start() 
        
        if type(signal) == type([]):                    # pokud zapsan dc hodnoty
            if not(signal[i] == value):
                SP.write("h" + str(signal[i])+ "\n")    # poslat poadovan hodnoty
                value = signal[i]
        if input == True:                               # pokud zjiovn vstup
            SP.write("u\n")                             #  poslat 'u'
            q = SP.readline()                           #  nast hodnotu vstupu
            try:
                u += [float(q)]                         # pevst na slo
            except:
                u += [0.0]
        if output == True:                              # pokud zjiovn vstup
            SP.write("y\n")                             #  poslat 'y'
            q = SP.readline()                           #  nast hodnotu vstupu
            try:
                y += [float(q)]                         # pevst na slo
            except:
                y += [0.0]
    T2 = time.time()                                    # Stopky - konec
    T3 = T2 - T1
    print T3                                            # vypsat opravdov as simulace             
    if (input == True) and (output == True):            # pokud se zjiovaly oba vstupy
         x = [0.0]*cycles
         for i in range(cycles):                        #  stmelit je dohromady do jedn tabulky
            x[i] = [u[i],y[i]]
    elif (input == True):                               # jinak ne
        x = u
    elif (output == True):
        x = y
    else:
        x = [0]
    SP.close()                                          # zavt port
    return x                                            # navrtit zjitn hodnoty
    
    
def COMsystem(TF1, COM):                                # funkce pro testovn komunikace po SP
    SP = Serial(COM, 115200, timeout=0.02)              # inicializace
    TF1 = rightTfZ(TF1)                                 # pepotn sprvnho formtu TfZ
    xi = SP.readline()                                  # ten z SP
    while not(xi == 'x'):                               # dokud se nepijme 'x'
        print xi
        try:
            xf = float(xi)                              # pevst data na slo
            for i in range(len(us)-1):                  # zpis minul hodnoty vstup a vstup pro vpoet
                us[-1-i] = us[-2-i]
                ys[-1-i] = ys[-2-i]
            us[0] = xf
            z1 = TF1[0][0]*us[0]                    # --- vpoet diskrtn funkce ---
            z2 = 0
            for j in range(len(TF1[0])-1):          #  vpoet vstupnch smyek
                z1 = z1 + TF1[0][j+1]*us[j+1]              
            for j in range(len(TF1[1])-1):          #  vpoet vstupnch smyek
                z2 = z2 + TF1[1][j+1]*ys[j+1]
            ys[0] = z1-z2                           #  vsledek
        
            SP.write(str(ys[0]) + "\n")             # odesln dat
            #print yi
        except:
            SP.write(str(0.0) + "\n")
        xi = SP.readline()                          # naten dal hodnoty
    SP.close()                                      # ukonen prce s portem

def plot(x,y,FileName = '',Title = 'Simulation', xLabel = 't [s]',yLabel = 'y [-]'):
    "Vykreslen grafu a uloen do souboru"

    if type(x[0]) == type([]):                      # pokud rozdln asy
        x = x[1]                                    # vzt as z bloku systmu
        
    pyplot.ioff()
    pyplot.clf()
    pyplot.figure(1)                                # nov graf
    if len(y) == 2:                                 # vykreslen grafu zapsan 2 tabulkami
        pyplot.plot(x, y[0],'b--', x, y[1],'g')     # vykreslen
        #pyplot.legend( ('pozadovana', 'skutecna') )
    elif type(y[0]) == type([]) and len(y[0]) > 1:  # vykreslen grafu zapsan vektorov
        y1 = [0.0]*len(x)
        y2 = [0.0]*len(x)
        for i in range(len(x)):                     # rozdlen vektor
            y1[i] = y[i][0]
            y2[i] = y[i][1]
        pyplot.plot(x, y1,'b', x, y2,'g--')         # vykreslen
        #pyplot.legend( ('pozadovana', 'skutecna') )
    else:
        pyplot.plot(x, y)                           # vykreslen normlnho grafu
    pyplot.xlabel(xLabel)                           # popisek osy x
    pyplot.ylabel(yLabel)                           # popisek osy y
    pyplot.title(Title)                             # nzev
    pyplot.grid(True)                               # zobrazen mky
    if not (FileName == ''):
        try:
            pyplot.savefig(FileName)                    # uloen do souboru simple_plot.png
        except:
            print 'Soubor ' + FileName + '.png se nepodailo uloit' # soubor se nepodailo uloit
        else:
            print 'Soubor ' + FileName + '.png byl uloen' # soubor uloen
    pyplot.show()                                   # zobrazit graf
    pyplot.close(1)                                 # zavt graf
    
def CreateC(File, Sys, StepTime, typ = 'double' ):      # --- Kompilace do souboru C ---
    if len(Sys) == 2:
        Sys = rightTfZ(Sys)
        StepCount = [len(Sys[0]) - 1,len(Sys[1]) - 1]  #  vpoet potu krok na zapamatovn
        if typ == 'int':                            # pokud int, tak zaokrouhlit
            for i in range(len(Sys[0])):
                Sys[0][i] = int(round(Sys[0][i]))
            for i in range(len(Sys[1])):
                Sys[1][i] = int(round(Sys[1][i]))
    else:
        Sys[1] = Sys[1]*StepTime                      # vpoet konstant PID regultoru 
        Sys[2] = Sys[2]/StepTime
        
        if typ == 'int':                            # pokud int, tak zaokrouhlit
            for i in range(len(Sys)):
                Sys[i] = int(round(Sys[i]))
                
    file = open(File + ".c",'w')			        #  otevt soubor
    
      
    file.write("/***********************************************************************\n")
    if len(Sys) == 2:
        file.write("* Regulator Z                                                          *\n")
    else:
        file.write("* Regulator PID                                                        *\n")
    file.write("***********************************************************************/\n\n")
      
      
    if len(Sys) == 3:
        file.write("/************* DEFINE CONSTANTS ***************/\n\n") # konstanty
        file.write("#define Kp " + str(Sys[0]) + "\n")
        file.write("#define Ki " + str(Sys[1]) + "\n")
        file.write("#define Kd " + str(Sys[2]) + "\n\n")
        #file.write("#define T " + str(StepTime) + "\n\n")
        
        #file.write("#define Ki_x Ki*T\n")
        #file.write("#define Kd_x Kd/T\n\n")
      
    file.write("/************* GLOBAL VARIABLES ***************/\n\n") # globln promnn
    if len(Sys) == 2:
        file.write(typ + " " + NameStep[0] + "[" + str(StepCount[0]+1) + "], " + NameStep[1] + "[" + str(StepCount[1]+1) + "];\n")
        file.write(typ + " " + NameTf[0] + "[" + str(len(Sys[0])) + "], " + NameTf[1] + "[" + str(len(Sys[0])) + "];\n\n")
    else:
        file.write(typ + " P, I, D, S;\n\n")
  
    file.write("/************* PROCEDURES *********************/\n\n") # podprogram
    # --- init() ---
    file.write("void init_reg(void)\n{\n") 
    if len(Sys) == 2:
        file.write("\tint i;\n\n")                          # inicializace Z-funkce
        file.write("\tfor(i = 0; i <= " + str(StepCount[0]) + "; i++)\n") #   posunout zaznamenan kroky o jedno
        file.write("\t\t" + NameStep[0] + "[i] = 0;\n")
        file.write("\tfor(i = 0; i <= " + str(StepCount[1]) + "; i++)\n") #   posunout zaznamenan kroky o jedno
        file.write("\t\t" + NameStep[1] + "[i] = 0;\n")
 
        for i in range(len(Sys[0])):
            file.write("\t" + NameTf[0] + "[" + str(i) + "] = " + str(Sys[0][i]) + ";\n") 
           
        for i in range(len(Sys[1])):
            file.write("\t" + NameTf[1] + "[" + str(i) + "] = " + str(Sys[1][i]) + ";\n") 
    else:
        file.write("\tP = 0;\n")                            # inicializace PID regultoru
        file.write("\tI = 0;\n")
        file.write("\tD = 0;\n")
        file.write("\tS = 0;\n")
    file.write("}\n\n") 
      
    # --- calculate(value) ---
    file.write(typ + " calculate(" + typ + " value)\n{\n")  #  IntTime() - interrupt Timeru
    if len(Sys) == 2:
        file.write("\t" + typ + " Val1, Val2;\n\n")         #   deklarace promnnch Val1, Val2
        if StepCount[0] > 1:                                #   pokud vc krok
            file.write("int i;\n")
            file.write("\tfor(i = " + str(StepCount[0]) + "; i >= 1; --i)\n") #   posunout zaznamenan kroky o jedno
            file.write("\t\t" + NameStep[0] + "[i] = " + NameStep[0] + "[i - 1];\n")
        elif StepCount[0] == 1:                             #   pokud jen jeden minul krok
            file.write("\t" + NameStep[0] + "[1] = " + NameStep[0] + "[0];\n") #   tak posunout jen o jedno
        if StepCount[1] > 1:                                #   pokud vc krok
            file.write("\tfor(i = " + str(StepCount[1]) + "; i >= 1; --i)\n") #   posunout zaznamenan kroky o jedno
            file.write("\t\t" + NameStep[1] + "[i] = " + NameStep[1] + "[i - 1];\n")
        elif StepCount[1] == 1:                             #   pokud jen jeden minul krok
            file.write("\t" + NameStep[1] + "[1] = " + NameStep[1] + "[0];\n") #   tak posunout jen o jedno
        file.write("\t" + NameStep[0] + "[0] = value;\n\n") #   nast data 
       
        # --- vpoet diskrtn penosov funkce ---
        file.write("\tVal1 = " + NameTf[0] + "[0] * " + NameStep[0] + "[0];\n")
        if StepCount[0] == 1:
            file.write("\tVal1 += " + NameTf[0] + "[1] * " + NameStep[0] + "[1];\n\n")
        else:
            file.write("\tfor(i = 1; i <= " + str(StepCount[0]) + "; i++)\n")
            file.write("\t\tVal1 += " + NameTf[0] + "[i] * " + NameStep[0] + "[i];\n\n")
      
      
        if StepCount[1] == 1:
            file.write("\tVal2 = " + NameTf[1] + "[1] * " + NameStep[1] + "[1];\n\n")
        else:
            file.write("\tVal2 = 0;\n")
            file.write("\tfor(i = 1; i <= " + str(StepCount[1]) + "; i++)\n")
            file.write("\t\tVal2 += " + NameTf[1] + "[i] * " + NameStep[1] + "[i];\n\n")
      
        file.write("\t" + NameStep[1] + "[0] = Val1 - Val2;\n")
        file.write("\treturn(" + NameStep[1] + "[0]);\n") # nvrat hodnoty
    else:
        # --- vpoet PID regultoru ---
        file.write("\tP = value * Kp;\n")               # vpoet P sloky
        file.write("\tI = I + Ki * value;\n")           # vpoet I sloky
        file.write("\tD = Kd * (value - S);\n")         # vpoet D sloky
        file.write("\tS = value;\n")                    # zapamatovnn si tto hodnoty
        file.write("\treturn(P + I + D);\n")            # nvrat hodnoty
        
    file.write("}\n\n")